#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: subInfo.pan,v 1.1 2004/09/06 14:47:13 cguirao Exp $" 
#
# subInfo.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Thu Nov 19 18:51:44 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#
set panUsrLib   {}  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .subInfo 
   set panUsrProcs {subInfoInit subInfoExit subInfoInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc subInfoInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc subInfoInit {} {

 # Declare global variables

   global gvar cv

 # User Initialization
set gvar(subInfoCancel) 0

set _top_level [winfo toplevel $cv]
    wm protocol $_top_level WM_DELETE_WINDOW "bell"

#grab .subInfo
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
set par(PANELX) 619 ;# Panel X position
set par(PANELY) 145 ;# Panel Y position
panCreateFrame subInfo ;# Create empty frame
panGetCvNames  subInfo cv bcv ;# Get Canvas Names
panInit        $argc $argv subInfo ;# Initialization



UifEntry           $cv.obsNameWdg -canvasAnchor nw -label {Observer Name} \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(obsName) -width 25
UifEntry           $cv.programIDWdg -canvasAnchor nw -label {Program ID} \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(programID) -width 13
UifButton          $cv.subInfo-wdg1 -canvasAnchor nw -command subInfoAccept \
                   -initialState normal -label OK -popup 0 \
                   -stateVar gvar(subInfo-wdg4Var) -width 20
UifButton          $cv.subInfo-wdg2 -canvasAnchor nw -command subInfoExit \
                   -initialState normal -label Cancel -popup 0 \
                   -stateVar gvar(subInfo-wdg6Var) -width 20

#
#  Canvas Items
#

$cv create text 84 8 -tags "text subInfo-item1" -anchor nw \
          -text "Subscriber Information" \
          -fill black -font -Adobe-helvetica-medium-r-normal--24* 

$cv create text 0 140 -tags "text subInfo-item2" -anchor nw \
          -text "----------------------------------------------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(obsNameWdg)  {UifEntry 32 104 1 0 {} 0 0 obsName 0 A {} {} 0 0 0 0}
set panWidget(programIDWdg)  {UifEntry 60 68 1 0 {} 0 0 programID 0 A {} {} 0 0 0 0}
set panWidget(subInfo-wdg1)  {UifButton 20 164 1 0 0 0 0 {} 0 {}}
set panWidget(subInfo-wdg2)  {UifButton 224 164 1 0 0 0 0 {} 0 {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(obsNameWdg)  {Insert your name and surname}
set panWidgetHlp(programIDWdg)  {Insert your Program ID [ PPP.C-NNNN(X) ]}

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 412x251
wm title     $panRoot "Subscription Information"
set par(TITLE) "Subscription Information" 

panMainStart  subInfo $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc subInfoExit {} {

 # Declare global variables

   global gvar popflag

if {$gvar(initFlag) == 1} {htPopUp "I need a program ID and a Name
to run dataSubscriber.\nDo you want to exit ?" 1 0 1
    if {$popflag == 1} { exit } else { return }
}

wm deiconify .
panClosePanel no .subInfo
 # Statements to be executed when exiting
}
