#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dominoPrefsAsto.pan,v 1.1 2004/09/06 14:47:14 cguirao Exp $" 
#
# dominoPrefsAsto.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Fri Dec 04 14:57:12 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#
set panUsrLib   {}  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dominoPrefsAsto 
   set panUsrProcs {dominoPrefsAstoInit dominoPrefsAstoExit dominoPrefsAstoInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dominoPrefsAstoInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dominoPrefsAstoInit {} {

 # Declare global variables

   global gvar

 # User Initialization
#return
dominoPrefsInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
panCreateFrame dominoPrefsAsto ;# Create empty frame
panGetCvNames  dominoPrefsAsto cv bcv ;# Get Canvas Names
panInit        $argc $argv dominoPrefsAsto ;# Initialization



UifEntry           $cv.dominoFromWdg -canvasAnchor nw -label From \
                   -labelFont -Adobe-helvetica-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(dominoFrom) -width 10
UifButton          $cv.dominoPrefsAsto-wdg1 -canvasAnchor nw \
                   -command dominoAcceptPrefs -initialState normal \
                   -label Accept -popup 0 \
                   -stateVar gvar(dominoPrefsAsto-wdg17Var) -width 10
UifButton          $cv.dominoPrefsAsto-wdg2 -canvasAnchor nw \
                   -command dominoPrefsClose -initialState normal \
                   -label Cancel -popup 0 \
                   -stateVar gvar(dominoPrefsAsto-wdg19Var) -width 10
UifEntry           $cv.dominoToWdg -canvasAnchor nw -label To \
                   -labelFont -Adobe-helvetica-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(dominoTo) -width 10

#
#  Canvas Items
#

$cv create text 0 4 -tags "text dominoPrefsAsto-item1" -anchor nw \
          -text "------Request Data---------------------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 0 120 -tags "text dominoPrefsAsto-item2" -anchor nw \
          -text "--------------------------------------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(dominoFromWdg)  {UifEntry 96.0 44.0 1 0 {} 0 0 dominoFrom 0 A {} {} 0 0 0 0}
set panWidget(dominoPrefsAsto-wdg1)  {UifButton 48.0 148.0 1 0 0 0 0 {} 0 {}}
set panWidget(dominoPrefsAsto-wdg2)  {UifButton 196.0 148.0 1 0 0 0 0 {} 0 {}}
set panWidget(dominoToWdg)  {UifEntry 112.0 68.0 1 0 {} 0 0 dominoTo 0 A {} {} 0 0 0 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(dominoFromWdg)  {Format: YYYY-MM-DD}
set panWidgetHlp(dominoPrefsAsto-wdg1)  {Accept configuration.}
set panWidgetHlp(dominoPrefsAsto-wdg2)  {Don't change configuration.}
set panWidgetHlp(dominoToWdg)  {Format: YYYY-MM-DD}

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 333x238
wm title     $panRoot "Domino Preferences"
set par(TITLE) "Domino Preferences" 

panMainStart  dominoPrefsAsto $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dominoPrefsAstoExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
