/***********************************************************************/
/* dfslogPurgeRecentMessages.sql                                       */
/*                                                                     */
/* This script is intended to be run periodically, archiving messages  */
/* and purging messages from the recent_message table which are over   */
/* three days old.                                                     */
/*                                                                     */
/* All "important" messages are moved to the archive_message table     */
/* prior to deleting from the recent_message table. To edit the        */
/* definition of "important messages", one must edit the               */
/* copy_messages_to_archive stored procedure in the dfslog database.   */
/*                                                                     */
/* This SQL script must be run as the "dfslog_dbo" or "sa" SYBASE user.*/
/*                                                                     */
/* To run the script, use a command similar to the following:          */
/*                                                                     */
/*  isql -U<usr> -S<server> -P <psswd> -i dfslogPurgeRecentMessages.sql*/
/*                                                                     */
/* Revision Log:                                                       */
/*                                                                     */
/* Date           Who                Comment                           */
/*---------------------------------------------------------------------*/
/* Apr 29 1999    N. Kornweibel      Original version.                 */
/* May 27 1999    N. Kornweibel      Added DUMP TRAN dfslog WITH NO_LOG*/
/*                                                                     */
/***********************************************************************/

USE dfslog
EXECUTE delete_old_messages @numDaysToKeep=3
go
/* end of script */
