/**
 * @author N. Kornweibel
 * @version 1.0
 * An interface to filtering OBComponents.
 */

package org.eso.gasgano.datamodel;

import org.eso.gasgano.datamodel.gui.OBComponent;

public interface OBComponentFilter {

    /**
     * @param f The OBComponent to be filtered.
     * @return True if the OBComponent passes the filter, else false.
     */
    public boolean accept(OBComponent f);

    /**
     * @return A description of the filter.
     */
    public String getDescription();
}

// end of file OBComponentFilter.java.
