package org.eso.ohs.instruments;


import java.util.StringTokenizer;


/**
 * Instancaites a class that repesrents a list of numbers.
 * The string that contains the list of numbers is checked for its validity.
 * The string uses spaces as its separator
 * <p>
 * $Id: IntListParameter.java,v 1.5 2001/07/25 12:15:11 tcanavan Exp $
 * @author Tim Canavan
 */


public class IntListParameter extends IntegerParameter {

    static final long serialVersionUID = 7599100272386084254L;

     /**
      * Constructor for IntListParameter
      *
      * @param parameterName Name of parameter
      */

     public IntListParameter(ParamMetaData pMeta) {
         super(pMeta);
     }

     /**
      * Tooltip text. This usually contains information about 
      * the range of values that can be entered
      *
      * @return tooltip text
      */
  

     public String getToolTipText() {
         boolean range=false;
         String tooltp = "Enter a valid String";
         if(getMinValue() != null
         && getMaxValue() != null)
             range = true;
         Integer[] validValues = getValidValues();
         StringBuffer validIntegers = new StringBuffer(20);
         if(validValues != null) {
	     for(int i=0;i<validValues.length;i++) {
                 validIntegers.append(validValues[i].intValue() + " ");
             }
         }
         StringBuffer rangeBuffer = null;
         if(range) {
             rangeBuffer = new StringBuffer();
             rangeBuffer.append(getMinValue());       
             rangeBuffer.append("..");
             rangeBuffer.append(getMaxValue());
	 } 
         if(range && validValues == null)
             tooltp = "List of Integers within range " + rangeBuffer.toString();
         if(!range && validValues != null)
             tooltp = "List of Integers from the list " + validIntegers.toString();
         if(range && validValues != null)
             tooltp = "List of Integers  within range  " + rangeBuffer.toString() + " or in list "
                                        + validIntegers.toString();
         if(!range && validValues == null)
             tooltp = "Enter list of integers";
         return tooltp;
     }


    public char getDBTypeCode() {
        return 'J';
    }

    /**
     * This method verifies a string is a list of integers
     * @param value String repesenting a list of integers
     * @return status The status of the value entered.
     */
  
     public boolean verifyValue(String value) {
         boolean status=true;
         if(value == null || value.length() == 0) {
	     return true;
         }
         StringTokenizer token = new StringTokenizer(value, " ");
         while(token.hasMoreElements()) {  
              String item = token.nextToken();
              status = super.verifyValue(item);
              if(!status) {                     
		  return status;
              }
          }
          return status;
     }

}




