package org.eso.ohs.persistence.account.service;

import java.util.Collection;

import org.eso.ohs.dfs.account.Account;
import org.eso.ohs.dfs.account.AccountProfile;
import org.springframework.dao.DataAccessException;

public interface AccountService {

	public Account getAccount(final Integer id) throws DataAccessException;

	public Account getAccount(String userName) throws DataAccessException;

	public Account getUserAndProfiles(String userName)
			throws DataAccessException;

	public AccountProfile getDefaultProfile(String userName)
			throws DataAccessException;

	public void updateProfile(AccountProfile accProfile)
			throws DataAccessException;

	public void create(Account account) throws DataAccessException;

	public void updateAccount(Account account) throws DataAccessException;

	public void changePassword(Account account) throws DataAccessException;

	public void delete(Account account) throws DataAccessException;

	public boolean accountExists(String userName) throws DataAccessException;

	public AccountProfile getDefaultProfile(final Account account)
			throws DataAccessException;

	public Account getAccountRoles(final String userName)
			throws DataAccessException;
}