package org.eso.ohs.phase2.actions;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.EmptyBorder;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.utilities.Utilities;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.ConstraintSetDTO;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.USDReadmeDatails;
import org.eso.ohs.dfs.USGLog;
import org.eso.ohs.persistence.dbase.phase2.USDFileDBIO;

/**
 * @author tcanavan
 *
 * To change this generated comment e dit the template variable "typecomment":
 * Window>Preferences>Java>Templates. To enable and disable the creation of type
 * comments go to Window>Preferences>Java>Code Generation.
 */
public class USDEditView
  extends JFrame {

    private Logger stdlog_ = Logger.getLogger(USDEditView.class);


    private JScrollPane pane_;
    
    private MainPanel mainPanel_ = new MainPanel();
    
    private JPanel northPanel = new JPanel();
    
    private JPanel southPanel = new JPanel();
    
    private JPanel centerPanel = new JPanel();

    private ObservingRun obsRun_;
    
    
    private Vector components_ = new Vector();
    
    
    private USDReadmeDatails usdReadmeDetails_;
    
    
    private JTextField specialRemarks = new JTextField();
    
    private JTextArea constraintSetText;

    
    
    private JTextArea mtsAbstract;
    
   
    private JTextArea usgLogText = new JTextArea();
    
    
    private JTextArea usgLogItem = new JTextArea();
    
    
    private JButton saveButton = new JButton("Save");
    
    
    private JButton addItemButton = new JButton("Add Support Log Item");
    
    
    private JCheckBox isPreImgBox = new JCheckBox();
    
    private JCheckBox isTimeCritBox = new JCheckBox();
    
    private JCheckBox isCarryOverBox = new JCheckBox();
    
    private JCheckBox isSpecialCalBox = new JCheckBox();
    
    private JCheckBox isChileanBox = new JCheckBox();
    
    private JButton cancelButton = new JButton("Cancel");
    
    private JLabel progIdLabel = new JLabel();
    
    private JLabel piLabel = new JLabel();

    
    private JComboBox reviewState = new JComboBox();
    
    private JLabel reviewResponsible = new JLabel();


    private boolean logEdited = false;
    

    private static USDEditView usgEditView;

    public static USDEditView getInstance() {
        if (usgEditView == null) {
            usgEditView = new USDEditView();
        }
        return usgEditView;
    }

    
    

    /**
     * Constructor for JPEGViewer.
     * @throws HeadlessException
     */
    private USDEditView() throws HeadlessException {
        super();
        mainPanel_.setLayout(new BorderLayout());
        pane_ = new JScrollPane(mainPanel_);        
        getContentPane().add(pane_);

        Insets insets = new Insets(4,4,4,4);
        
        northPanel.setLayout(new GridBagLayout());
        northPanel.setBorder(new EmptyBorder(insets));
        centerPanel.setLayout(new GridBagLayout());
        centerPanel.setBorder(new EmptyBorder(insets));
        southPanel.setLayout(new GridBagLayout());
        southPanel.setBorder(new EmptyBorder(insets));
        
        
        mainPanel_.add(BorderLayout.NORTH,northPanel);
        mainPanel_.add(BorderLayout.CENTER,centerPanel);
        mainPanel_.add(BorderLayout.SOUTH,southPanel);
        
        saveButton.addActionListener(new SaveUSDFileAction());
        
        addItemButton.addActionListener(new AddLogItemAction());

        cancelButton.addActionListener(new CancelAction());
        
        
        JMenuBar mb = new JMenuBar();
        String menuName = "File";
        JMenu menu = new JMenu(menuName);
        JMenuItem close = new JMenuItem("Close");

        close.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_W, InputEvent.CTRL_MASK, false));
        close.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                closeUSDEdit();
            }
        });
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        WindowAdapter wl = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                closeUSDEdit();
            }
        };
        addWindowListener(wl);

        
        
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.anchor = GridBagConstraints.WEST;
        addSummaryInfo(gbc);
        menu.add(close);
        mb.add(menu);
        setJMenuBar(mb);

        JLabel label = new JLabel("Constraint Sets");
        centerPanel.add(label,gbc);
        gbc.gridx=0;
        gbc.gridy++;
        gbc.weightx=1;
        constraintSetText = new JTextArea(3,70);
        constraintSetText.setWrapStyleWord(true);
        constraintSetText.setLineWrap(true);
        constraintSetText.setEditable(false);
        JScrollPane pane = new JScrollPane(constraintSetText);
        centerPanel.add(pane,gbc);
        gbc.weightx=0;
        gbc.gridy++;        
        gbc.weightx=0;

        
        
        label = new JLabel("Special Remarks");
        centerPanel.add(label,gbc);
        gbc.gridx=0;
        gbc.gridy++;
        gbc.weightx=1;
        centerPanel.add(specialRemarks, gbc);
        gbc.gridx = 0;
        gbc.gridy++;        
        gbc.weightx=0;
        
        label = new JLabel("MTS Abstract");
        centerPanel.add(label,gbc);
        gbc.gridy++;
        gbc.gridx=0;
        gbc.weightx=1;

        mtsAbstract = new JTextArea(8,70);
        mtsAbstract.setWrapStyleWord(true);
        mtsAbstract.setLineWrap(true);        
        JScrollPane paneMTS = new JScrollPane(mtsAbstract);
        centerPanel.add(paneMTS,gbc);
        gbc.weightx=0;
        gbc.gridy++;        
        gbc.weightx=0;
        
        
        label = new JLabel("Support Log");
        southPanel.add(label,gbc);
        gbc.gridy++;
        gbc.gridx=0;
        gbc.weightx=1;

        usgLogText = new JTextArea(8,70);
        usgLogText.setWrapStyleWord(true);
        usgLogText.setLineWrap(true);
        usgLogText.setEditable(false);      
        pane = new JScrollPane(usgLogText);
        southPanel.add(pane,gbc);
        gbc.weightx=0;
        gbc.gridy++;        
        gbc.weightx=0;
        
        
        label = new JLabel("");
        southPanel.add(label,gbc);
        gbc.gridy++;
        gbc.gridx=0;
        gbc.weightx=1;

        usgLogItem = new JTextArea(4,70);
        usgLogItem.setWrapStyleWord(true);
        usgLogItem.setLineWrap(true);
        pane = new JScrollPane(usgLogItem);
        southPanel.add(pane,gbc);
        gbc.weightx=0;
        gbc.gridy++;        
        gbc.weightx=0;
        gbc.gridx=0;
        southPanel.add(addItemButton,gbc);
        gbc.gridx++;
        gbc.weightx=0;
        southPanel.add(saveButton,gbc);
        gbc.gridx++;
        gbc.weightx=0;        
        southPanel.add(cancelButton,gbc);
        gbc.gridx++;
        gbc.weightx=0;
    }
    
    
    private void closeUSDEdit() {
        if(isEdited()) {
            int n = askSaveQuestion();
            if(n==JOptionPane.YES_OPTION) {
                obsRun_=null;
                usdReadmeDetails_=null;
                setVisible(false); 
            } else {
                return;
            }
        } else {
            usdReadmeDetails_=null;
            obsRun_=null;
            setVisible(false);
        }
    }


    public void init(ObservingRun obsRun,USDReadmeDatails readmeDetails) {
        if(obsRun_ != null && obsRun_.getId() != obsRun.getId()) {
            if(isEdited()) {
                String message =
                    "USD File for "
                        + obsRun_.getProgId()
                        + "' is open and modified. "
                        + " Do you sish to save this before continuing ?";
                int n =
                    JOptionPane.showConfirmDialog(
                        null,
                        message,
                        "Save",
                        JOptionPane.YES_NO_OPTION);
                if(n==JOptionPane.YES_OPTION) {
                    saveData();
                }
            }
        }
        obsRun_ = obsRun;
        usdReadmeDetails_ = readmeDetails;
        setObject(readmeDetails);
        repaint();
        setVisible(true);
        pack();
    }



    private void addSummaryInfo(GridBagConstraints gbc) {
        
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridheight = 1;
        gbc.gridwidth = 1;
        
        JLabel label = new JLabel("Observing Run : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(progIdLabel, gbc);
        gbc.gridx = 0;
        gbc.gridy++;        
        gbc.weightx=0;
        
        label = new JLabel("Principal Investigator Name : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(piLabel,gbc);
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;
        
        label = new JLabel("USD Review State : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        reviewState = new JComboBox(USDReadmeDatails.statusValues.valuesAsStrings());
        northPanel.add(reviewState, gbc);
        gbc.gridy++;
        gbc.weightx=0;
        gbc.gridx = 0;
        
        
        label = new JLabel("USD Responsible : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(reviewResponsible, gbc);
        gbc.gridy++;
        gbc.weightx=0;
        gbc.gridx = 0;
        
        
        
        label = new JLabel("PREIMAGING : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(isPreImgBox, gbc);
        isPreImgBox.setEnabled(false);
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;

        label = new JLabel("CHILEAN : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(isChileanBox, gbc);
        isChileanBox.setEnabled(false);
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;
        
        gbc.fill = GridBagConstraints.NONE;


        label = new JLabel("SPECIAL CALIBRATIONS : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(isSpecialCalBox, gbc);
        isSpecialCalBox.setPreferredSize(new Dimension(40,20));
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;

                
        label = new JLabel("TIME-CRITICAL : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(isTimeCritBox, gbc);
        isTimeCritBox.setPreferredSize(new Dimension(40,20));
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;
        
        
        label = new JLabel("CARRYOVER : ");
        northPanel.add(label, gbc);
        gbc.gridx++;
        gbc.weightx=1;
        northPanel.add(isCarryOverBox, gbc);
        isCarryOverBox.setPreferredSize(new Dimension(40,20));
        gbc.gridy++;
        gbc.gridx = 0;
        gbc.weightx=0;
        gbc.fill = GridBagConstraints.HORIZONTAL;

    }
    
    public void setObject(USDReadmeDatails usdReadmeDetails) {
        removeAllFocusListeners();
        piLabel.setText(obsRun_.getPIName());
        progIdLabel.setText(obsRun_.getProgId());
        String status = (String)USDReadmeDatails.statusValues.get(usdReadmeDetails_.getReviewStatus());
        reviewState.setSelectedItem(status.trim());
        components_.addElement(reviewState);
        specialRemarks.setText(usdReadmeDetails_.getSpecialComments());
        components_.addElement(specialRemarks);
        reviewResponsible.setText(usdReadmeDetails_.getUsdStaffName());
        components_.addElement(reviewResponsible);
        isTimeCritBox.setSelected(usdReadmeDetails.isTimeCritical());
        components_.addElement(isTimeCritBox);
        isChileanBox.setSelected(usdReadmeDetails.isChilean());
        components_.addElement(isChileanBox);
        isCarryOverBox.setSelected(usdReadmeDetails.isCarryOver());
        components_.addElement(isCarryOverBox);
        isSpecialCalBox.setSelected(usdReadmeDetails.isSpecialCal());
        components_.addElement(isSpecialCalBox);
        isPreImgBox.setSelected(usdReadmeDetails.isPreImaging());
        components_.addElement(isPreImgBox);
        stdlog_.debug("NTS ABSTRACT " + usdReadmeDetails.getMtsAbstract());
        mtsAbstract.setText(usdReadmeDetails.getMtsAbstract());
        components_.addElement(mtsAbstract);
        components_.addElement(usgLogItem);
        for(int i=0;i<components_.size();i++) {
            addFocusListenerMPanel((JComponent)components_.elementAt(i));
        }
        USGLog []  logs  =  usdReadmeDetails.getUsgLog();
        StringBuffer buf = new StringBuffer();
        for(int i=0;i<logs.length;i++) {
            buf.append(Convert.longToISODate(logs[i].getLogTime()) + "\n");
            buf.append(logs[i].getLogMessage() + "\n\n");
        }
        buf.toString();
        usgLogText.setText(buf.toString());
        usgLogText.setCaretPosition(0);
        ConstraintSetDTO [] dtos = usdReadmeDetails.getCsDtos();       
        StringBuffer csbuf = new StringBuffer();
        csbuf.append("Airmass Sky Transparency Seeing FLI Moon Distance OB Count\n");
        for(int i=0;i<dtos.length;i++) {
            csbuf.append(dtos[i].getAirmass()          + "     ");
            csbuf.append("      " + dtos[i].getSkyTransparency() + "        ");
            csbuf.append(dtos[i].getSeeing() +         "   ");
            csbuf.append(dtos[i].getFractionalLunarIllumination() + "      ");
            csbuf.append(dtos[i].getMoonAngularDistance() + "         ");
            csbuf.append(dtos[i].getCount() + "      ");
            csbuf.append("\n");
            
        }
        constraintSetText.setText(csbuf.toString());
        constraintSetText.setCaretPosition(0);
        setTitle("USD File " + obsRun_.getProgId());
    }
    
    private void addFocusListenerMPanel(JComponent comp) {
        comp.addFocusListener(mainPanel_);
    }
    
    private void removeAllFocusListeners() {
        for(int i=0;i<components_.size();i++) {
            JComponent comp = (JComponent)components_.elementAt(i);
            comp.removeFocusListener(mainPanel_);
        }
        components_.removeAllElements();
        
    }

    
    
    public void setTitle() {
        if(isEdited())
            super.setTitle("User Support File " + obsRun_.getProgId() + " **");
        else {
            super.setTitle("User Support File " + obsRun_.getProgId());
        }
    }
    
    public boolean isEdited() {
        if(isTimeCritBox.isSelected() != usdReadmeDetails_.isTimeCritical()) {
            return true;
        }
        if(isChileanBox.isSelected() != usdReadmeDetails_.isChilean()) {
            return true;
        }
        if(isCarryOverBox.isSelected() != usdReadmeDetails_.isCarryOver()) {
            return true;
        }
        if(isSpecialCalBox.isSelected() != usdReadmeDetails_.isSpecialCal()) {
            return true;
        }
        if(isPreImgBox.isSelected() != usdReadmeDetails_.isPreImaging()) {
            return true;
        }
        String abstractText = mtsAbstract.getText();
        if(abstractText == null)
            abstractText="";
        if(!abstractText.equals(usdReadmeDetails_.getMtsAbstract())) {
            return true;
        }
        
        String specialRemarksStr = specialRemarks.getText();
        if(specialRemarksStr == null)
            specialRemarksStr="";
        if(!specialRemarksStr.equals(usdReadmeDetails_.getSpecialComments())) {
            return true;
        }
        String selectedItem = (String)reviewState.getSelectedItem();
        stdlog_.debug("Selected Item = " + selectedItem);
        String currentReviewState = USDReadmeDatails.statusValues.getKeyFromObjectAsString(selectedItem);
        if(!currentReviewState.equals(usdReadmeDetails_.getReviewStatus())) {
            return true;
        }
        if(logEdited || usgLogItem.getText().length() > 0)
           return true;
        return false;
    }
    
        
    private class SaveUSDFileAction extends AbstractAction {

        public SaveUSDFileAction() {
            super("Save");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
            Utilities.waitCursor(USDEditView.this);
            saveData();
            Utilities.normalCursor(USDEditView.this);

            
        }

    }
    
    private void saveData() {
        try {
            if(isEdited()) {
               appendLogItem();
               assignData();
               USDFileDBIO.write(usdReadmeDetails_,obsRun_.getId());
               logEdited=false;
               setTitle();
            }
        } catch (ObjectIOException e) {
            ErrorMessages.announceIOError(USDEditView.this,e);
        }
    }

    
    
    
    
    private class AddLogItemAction extends AbstractAction {

        public AddLogItemAction() {
            super("Add Log History Item");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
              appendLogItem();
        }
    }
    
    private class CancelAction extends AbstractAction {

        public CancelAction() {
            super("Cancel");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
            if(isEdited()) {
                int n = askSaveQuestion();
                if(n==JOptionPane.YES_OPTION) {
                    obsRun_=null;
                    usdReadmeDetails_=null;
                    setVisible(false); 
                } else {
                    return;
                }
            } else {
                obsRun_=null;
                usdReadmeDetails_=null;
                setVisible(false); 
            }
        }

    }
    
    
    public int askSaveQuestion() {
        String message =
            "USD File for "
                + obsRun_.getProgId()
                + "' was modified. \nAll changes will be lost."
                + " Are you sure?";
        int n =
            JOptionPane.showConfirmDialog(
                null,
                message,
                "Revert",
                JOptionPane.YES_NO_OPTION);
        return n;  
    } 

    
     public void assignData() {
        usdReadmeDetails_.setTimeCritical(isTimeCritBox.isSelected());
        usdReadmeDetails_.setChilean(isChileanBox.isSelected());
        usdReadmeDetails_.setCarryOver(isCarryOverBox.isSelected());
        usdReadmeDetails_.setSpecialCal(isSpecialCalBox.isSelected());
        usdReadmeDetails_.setTimeCritical(isTimeCritBox.isSelected());
        usdReadmeDetails_.setPreImaging(isPreImgBox.isSelected());
        String abstractText = mtsAbstract.getText();
        if(abstractText == null)
            abstractText="";
        usdReadmeDetails_.setMtsAbstract(abstractText);
        
        String selectedItem = (String)reviewState.getSelectedItem();
        stdlog_.debug("Selected Item = " + selectedItem);
        usdReadmeDetails_.setReviewStatus(USDReadmeDatails.statusValues.getKeyFromObjectAsString(selectedItem));

        
        String specialComments = specialRemarks.getText();
        if(specialComments == null)
            specialComments ="";
        stdlog_.debug("Spec Comments " + specialComments);
        usdReadmeDetails_.setSpecialComments(specialComments);

    }
    private void appendLogItem() {
          String logItemText = usgLogItem.getText();
          if(logItemText.length() <= 0) {
              return;
          }
          usgLogText.setText("");
          USGLog [] usgLog  = usdReadmeDetails_.getUsgLog();
          Vector log = new Vector();
          for(int i=0;i<usgLog.length;i++) {
               log.addElement(usgLog[i]);
          }
          USGLog newLog = createLogItem();
          log.addElement(newLog);
          System.out.println("Log Siyze" + log.size());
          setLog(log);              
          logEdited=true;
          USGLog [] newLogArray = new USGLog[log.size()];
          log.copyInto(newLogArray);
          usdReadmeDetails_.setUsgLog(newLogArray);
          usgLogItem.setText("");
    }
    
    private USGLog createLogItem() {
          USGLog newLog = new USGLog();
          newLog.setLogMessage(usgLogItem.getText());
          newLog.setLogTime(Convert.getCurrentTime());
        return newLog;
    }

    /**
     * @param log
     */
    private void setLog(Vector log) {
        for(int i=0;i<log.size();i++) {
              USGLog usgLogItem = (USGLog)log.elementAt(i);
              usgLogText.append(Convert.longToISODate(usgLogItem.getLogTime()) + "\n");
              usgLogText.append(usgLogItem.getLogMessage() + "\n\n");
          }
    }
    
    private class MainPanel extends JPanel implements FocusListener {

        /* (non-Javadoc)
         * @see java.awt.event.FocusListener#focusGained(java.awt.event.FocusEvent)
         */
        public void focusGained(FocusEvent arg0) {
        }

        /* (non-Javadoc)
         * @see java.awt.event.FocusListener#focusLost(java.awt.event.FocusEvent)
         */
        public void focusLost(FocusEvent arg0) {
            if(arg0.isTemporary())
                return;
            setTitle();
                
        }
    }


}
