package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.dfs.Seeing;
import org.eso.ohs.dfs.SkyTransparency;
import org.eso.ohs.phase2.apps.ot.gui.SkyTransparencyCellRenderer;

import com.jeta.forms.components.image.ImageComponent;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * Class ObservingConditionFilterView
 * 
 * The wizard page for the observing condition
 * 
 * @version $Revision: 1.10 $
 * @author ddorigo, Nov 3, 2005
 */

// $Id: ObservingConditionFilterView.java,v 1.6 2005/11/03 09:15:04 ddorigo Exp
// $
public class ObservingConditionFilterView extends OHSWizardPage {

    private static final long serialVersionUID = 1L;

    JPanel jpanel = new JPanel();

    JLabel labelTitle = new JLabel();

    JLabel labelPageTitle = new JLabel();

    JLabel labelSeeing = new JLabel();

    JLabel labelSkyTransparency = new JLabel();

    JLabel labelStrehlRatio = new JLabel();

    JTextField textFieldSeeing = new JTextField();

    JComboBox comboFieldSkyTransparency = new JComboBox();

    ImageComponent orange = new ImageComponent();

    JLabel labelInfo = new JLabel();

    JLabel labelMandatory = new JLabel();

    JRadioButton radioButtonInactiveSeeing = new JRadioButton();

    ButtonGroup buttongroupSeeing = new OHSButtonGroup(OrangWizard.BUTTONGROUP_SEEING);

    JRadioButton radioButtonActiveSeeing = new JRadioButton();

    JRadioButton radioButtonInactiveSky = new JRadioButton();

    ButtonGroup buttongroupSky = new OHSButtonGroup(OrangWizard.BUTTONGROUP_SKY);

    JRadioButton radioButtonActiveSky = new JRadioButton();

  
    private OrangWidgetsData defData;

    /**
     * Default constructor
     * 
     * @param defaultData
     */
    public ObservingConditionFilterView(OHSWizard controller,
            OrangWidgetsData defaultData) {
        super(controller);
        defData = defaultData;
        initializePanel();
    }

    /**
     * Adds fill components to empty cells in the first row and first column of
     * the grid. This ensures that the grid spacing will be the same as shown in
     * the designer.
     * 
     * @param cols
     *            an array of column indices in the first row where fill
     *            components should be added.
     * @param rows
     *            an array of row indices in the first column where fill
     *            components should be added.
     */
    void addFillComponents(Container panel, int[] cols, int[] rows) {
        Dimension filler = new Dimension(10, 10);

        boolean filled_cell_11 = false;
        CellConstraints cc = new CellConstraints();
        if (cols.length > 0 && rows.length > 0) {
            if (cols[0] == 1 && rows[0] == 1) {
                /** add a rigid area */
                panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                filled_cell_11 = true;
            }
        }

        for (int index = 0; index < cols.length; index++) {
            if (cols[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
        }

        for (int index = 0; index < rows.length; index++) {
            if (rows[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
        }

    }

    public JPanel createjpanel() {
       jpanel.setName("jpanel");
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,LEFT:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel.setLayout(formlayout1);

       labelPageTitle.setFont(new Font("sansserif",Font.ITALIC,11));
       labelPageTitle.setName("labelPageTitle");
       labelPageTitle.setText("Step 2: specify current observing conditions");
       jpanel.add(labelPageTitle,cc.xywh(2,3,11,1));

       labelSeeing.setName("labelSeeing");
       labelSeeing.setText("Seeing *");
       labelSeeing.setToolTipText("The Seeing  is between 0.2 and 2");
       jpanel.add(labelSeeing,cc.xy(2,7));

       labelSkyTransparency.setName("labelSkyTransparency");
       labelSkyTransparency.setText("Sky transparency *");
       jpanel.add(labelSkyTransparency,cc.xy(2,9));

       textFieldSeeing.setName("textFieldSeeing");
       jpanel.add(textFieldSeeing,cc.xy(11,7));

       comboFieldSkyTransparency.setName("comboFieldSkyTransparency");
       jpanel.add(comboFieldSkyTransparency,cc.xy(11,9));

       labelInfo.setName("labelInfo");
       labelInfo.setText("0 Observation blocks loaded");
       jpanel.add(labelInfo,cc.xy(2,21));

       labelMandatory.setName("labelMandatory");
       labelMandatory.setText("* Mandatory field");
       jpanel.add(labelMandatory,cc.xy(2,19));

       radioButtonInactiveSeeing.setActionCommand("Inactive");
       radioButtonInactiveSeeing.setName("radioButtonInactiveSeeing");
       radioButtonInactiveSeeing.setText("Inactive");
       buttongroupSeeing.add(radioButtonInactiveSeeing);
       jpanel.add(radioButtonInactiveSeeing,cc.xy(4,7));

       radioButtonActiveSeeing.setActionCommand("Active");
       radioButtonActiveSeeing.setName("radioButtonActiveSeeing");
       radioButtonActiveSeeing.setText("Active");
       buttongroupSeeing.add(radioButtonActiveSeeing);
       jpanel.add(radioButtonActiveSeeing,cc.xy(6,7));

       radioButtonInactiveSky.setActionCommand("JRadioButton");
       radioButtonInactiveSky.setName("radioButtonInactiveSky");
       radioButtonInactiveSky.setText("Inactive");
       buttongroupSky.add(radioButtonInactiveSky);
       jpanel.add(radioButtonInactiveSky,cc.xy(4,9));

       radioButtonActiveSky.setActionCommand("JRadioButton");
       radioButtonActiveSky.setName("radioButtonActiveSky");
       radioButtonActiveSky.setText("Active");
       buttongroupSky.add(radioButtonActiveSky);
       jpanel.add(radioButtonActiveSky,cc.xy(6,9));

       jpanel.add(WizardTitlePanel.createPanel(),cc.xywh(1,1,12,1));
       addFillComponents(jpanel,new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21 });
       return jpanel;
    }

   

    /**
     * Initializer
     */
    protected void initializePanel() {
        setLayout(new BorderLayout());
        add(createjpanel(), BorderLayout.CENTER);
        String[] skyTranspList = defData.getSkyTranspList();
        comboFieldSkyTransparency
                .setRenderer(new SkyTransparencyCellRenderer());
        addItems(comboFieldSkyTransparency, skyTranspList);
        listenTo(textFieldSeeing);
        listenTo(comboFieldSkyTransparency);

        listenTo(radioButtonInactiveSeeing);
        listenTo(radioButtonInactiveSky);

        listenTo(radioButtonActiveSeeing);
        listenTo(radioButtonActiveSky);

        radioButtonActiveSeeing.setSelected(true);
        radioButtonActiveSky.setSelected(true);

        radioButtonActiveSeeing.doClick();
        radioButtonActiveSky.doClick();
    }

    protected boolean isReady() {

        boolean seeingOk = false;
        boolean skyOk = false;
          
        if (radioButtonInactiveSeeing
                .isSelected()) {
            seeingOk = true;
        } else { // seeing value to be entered
            if (Seeing.isValidSeeing(textFieldSeeing.getText())) {
                seeingOk = true;
            }
        }
        if (radioButtonInactiveSky
                .isSelected()) {
            skyOk = true;
        } else { // seeing value to be entered
            if (SkyTransparency
                    .isValidSky((String) comboFieldSkyTransparency
                            .getSelectedItem())) {
                skyOk = true;
            }
        }
        boolean result = seeingOk && skyOk;
        return result;
    }

    public void setInfo(String info) {
        this.labelInfo.setText(info);
    }

}
