package org.eso.ohs.phase2.apps.ot.wizard;

import java.util.Date;

import org.eso.ohs.dfs.Seeing;
import org.eso.ohs.dfs.SkyTransparency;
import org.eso.ohs.dfs.StrehlRatio;
import org.eso.ohs.dfs.WeatherConstraint;
import org.eso.ohs.phase2.visibility.VisicalcOptions;

public interface OrangModel {

    public final static int OB_SELECTION_TELESCOPE = 0;

    public final static int OB_SELECTION_INSTRUMENT = 1;

    public final static int OB_SELECTION_QUEUES = 2;

    public static final int OB_SELECTION_WRONG = -1; 

    public abstract String getObSelectionQueue();

    public abstract String [] getSelectedQueues();
    
    public abstract String getObSelectionTelescope();

    public abstract int getObSelectionType();

    public abstract Date getStartDate();

    public abstract Date getEndDate();
    
    public abstract String getEndISODate();
    
    public abstract int getStepInterval();
      
    public abstract Seeing getSeeingValue();

    public abstract SkyTransparency getSkyTransp();

    public abstract StrehlRatio getStrehlRatio();


    public abstract int getAirmassValuePercentage();


    public abstract boolean isFliConstrain();


    public abstract int getFliRelaxPercentage();

    public abstract boolean isMoonAngleConstrain();

    public abstract boolean isTimeIntervalConstrain();

    public abstract boolean isSidTimeIntervalConstrain();

    public abstract int getMoonAngleDegree();

    public abstract boolean isMoonDistanceConstrain();

    public abstract int getMoonRelaxPercentage();

    public abstract boolean isSunAngleConstrain();

    public abstract int getSunAngleDegree();

    public abstract String getRankingAlgorithm();
    
    public abstract String getTimelineAlgorithm();

    public abstract String getUser();
    
    public abstract boolean isSuperUser();

    public abstract VisicalcOptions getVisiCalcOptions();

    public abstract double getLatitude();

    public abstract double getLongitude();

    public abstract String getStartISODate();
    
    public abstract boolean isTelescopeZenithConstraint();

    /**
     * @return String[] the current today queues  assigned the current telescope
     */
    public abstract String[] getQueuesTelescopes(); 

    /**
     * @return String[]  the current today queues  assigned the current instrument
     */
    public abstract String[] getQueuesInstruments();

    /**
     * @return WeatherConstraint the curent weather constraint 
     */
      public abstract WeatherConstraint getWeatherConstraint();  

}